///****************************************************************************
//
//	Copyright 2011 by WinSystems Inc.
//
//	Permission is hereby granted to the purchaser of WinSystems CPU products
//  to distribute any binary file or files compiled using this source code
//	directly or in any work derived by the user from this file. In no case
//	may the source code, original or derived from this file, be distributed
//	to any third party except by explicit permission of WinSystems. This file
//	is distributed on an "as-is" basis and no warranty as to performance or
//	fitness of purposes is expressed or implied. In no case shall WinSystems
//	be liable for any direct or indirect loss or damage, real or consequential
//	resulting from the usage of this source code. It is the user's sole
//	responsibility to determine fitness for any considered purpose.
//
///****************************************************************************
//
//	Name	 : mio_io.h
//
//	Project	 : PCM-MIO-G Windows Header File
//
//	Author	 : Paul DeMetrotion
//
///****************************************************************************
//
//	  Date		Revision	                Description
//	--------	--------	---------------------------------------------
//	 11/8/11	   1.0		  Original Release
//
///****************************************************************************

#define MAX_DEV 4
#ifdef MIO_IO_EXPORTS
#define MIO_IO_API __declspec(dllexport)
MIO_IO_API int mio_error_code;
MIO_IO_API char mio_error_string[128];
MIO_IO_API float adc_bitval[MAX_DEV][16] = {.00, .00, .00, .00, .00, .00, .00, .00,
								   .00, .00, .00, .00, .00, .00, .00, .00,
								   .00, .00, .00, .00, .00, .00, .00, .00,
								   .00, .00, .00, .00, .00, .00, .00, .00,
								   .00, .00, .00, .00, .00, .00, .00, .00,
								   .00, .00, .00, .00, .00, .00, .00, .00,
								   .00, .00, .00, .00, .00, .00, .00, .00,
								   .00, .00, .00, .00, .00, .00, .00, .00 };
MIO_IO_API USHORT adc_adjust[MAX_DEV][16] = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
											0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
											0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
											0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };
MIO_IO_API float adc_offset[MAX_DEV][16] = { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
									0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 
									0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
									0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 
									0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
									0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 
									0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,
									0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 };

#else
#define MIO_IO_API __declspec(dllimport)
#endif

// error codes
#define MIO_SUCCESS 0
#define MIO_OPEN_ERROR 1
#define MIO_TIMEOUT_ERROR 2
#define MIO_BAD_CHANNEL_NUMBER 3
#define MIO_BAD_MODE_NUMBER 4
#define MIO_BAD_RANGE 5
#define MIO_COMMAND_WRITE_FAILURE 6
#define MIO_READ_DATA_FAILURE 7
#define MIO_MISSING_IRQ 8
#define MIO_ILLEGAL_VOLTAGE 9
#define MIO_MAX_DEV 10

#define DAC_BUSY 0x80

#define DAC_SPAN_UNI5  0
#define DAC_SPAN_UNI10 1
#define DAC_SPAN_BI5   2
#define DAC_SPAN_BI10  3
#define DAC_SPAN_BI2   4
#define DAC_SPAN_BI7   5

#define	ADC_SINGLE_ENDED 0x80
#define ADC_DIFFERENTIAL 0x00

#define ADC_UNIPOLAR  0x08
#define ADC_BIPOLAR   0x00

#define ADC_TOP_5V	  0x00
#define ADC_TOP_10V	  0x04

#define ADC_CH0_SELECT 0x00
#define ADC_CH1_SELECT 0x40
#define ADC_CH2_SELECT 0x10
#define ADC_CH3_SELECT 0x50
#define ADC_CH4_SELECT 0x20
#define ADC_CH5_SELECT 0x60
#define ADC_CH6_SELECT 0x30
#define ADC_CH7_SELECT 0x70

#define FALLING 1
#define RISING  0

// This class is exported from the MIO_io.dll
class MIO_IO_API CMIO_io {
public:
	CMIO_io(void);
};

MIO_IO_API int fnMIO_io(void);

// analog input functions
extern "C" MIO_IO_API float adc_get_channel_voltage(int devNum, int channel);
extern "C" MIO_IO_API int adc_buffered_channel_conversions(int devNum, UCHAR *input_channel_buffer,USHORT *buffer);
extern "C" MIO_IO_API int adc_convert_all_channels(int devNum, unsigned short *buffer);
extern "C" MIO_IO_API int adc_convert_single_repeated(int devNum, int channel, unsigned count, USHORT *buffer);
extern "C" MIO_IO_API float adc_convert_to_volts(int devNum, int channel, USHORT value);
extern "C" MIO_IO_API float adc_auto_get_channel_voltage(int devNum, int channel);
extern "C" MIO_IO_API USHORT adc_read_conversion_data(int devNum, int channel);
extern "C" MIO_IO_API UCHAR adc_read_status(int devNum, int adc_num);
extern "C" MIO_IO_API int adc_set_channel_mode(int devNum, int channel, int input_mode,int duplex,int range);
extern "C" MIO_IO_API int adc_start_conversion(int devNum, int channel);
extern "C" MIO_IO_API int adc_wait_ready(int devNum, int channel);
extern "C" MIO_IO_API int disable_adc_interrupt(int devNum, int adc_num);
extern "C" MIO_IO_API int enable_adc_interrupt(int devNum, int adc_num);
extern "C" MIO_IO_API int set_adc_event(int devNum, int adc_num, HANDLE adc_event);
extern "C" MIO_IO_API int write_adc_command(int devNum, int adc_num,UCHAR value);

// analog output functions
extern "C" MIO_IO_API int buffered_dac_output(int devNum, UCHAR *cmd_buff,USHORT *data_buff);
extern "C" MIO_IO_API UCHAR dac_read_status(int devNum, int dac_num);
extern "C" MIO_IO_API int disable_dac_interrupt(int devNum, int dac_num);
extern "C" MIO_IO_API int enable_dac_interrupt(int devNum, int dac_num);
extern "C" MIO_IO_API int set_dac_event(int devNum, int dac_num, HANDLE dac_event);
extern "C" MIO_IO_API int set_dac_output(int devNum, int channel, USHORT dac_value);
extern "C" MIO_IO_API int set_dac_span(int devNum, int channel, unsigned char span_value);
extern "C" MIO_IO_API int set_dac_voltage(int devNum, int channel, float voltage);
extern "C" MIO_IO_API int wait_dac_ready(int devNum, int channel);
extern "C" MIO_IO_API int write_dac_command(int devNum, int dac_num,UCHAR value);
extern "C" MIO_IO_API int write_dac_data(int devNum, int offset, USHORT value);

// DIO functions
extern "C" MIO_IO_API int dio_clr_bit(int devNum, int bit_number);
extern "C" MIO_IO_API int dio_clr_int(int devNum, int bit_number);
extern "C" MIO_IO_API int dio_disable_bit_int(int devNum, int bit_number);
extern "C" MIO_IO_API int dio_enable_bit_int(int devNum, int bit_number, int polarity);
extern "C" MIO_IO_API int dio_get_int(int devNum);
extern "C" MIO_IO_API int dio_init_io(int devNum);
extern "C" MIO_IO_API int dio_read_bit(int devNum, int bit_number);
extern "C" MIO_IO_API int dio_set_bit(int devNum, int bit_number);
extern "C" MIO_IO_API int dio_write_bit(int devNum, int bit_num, int val);
extern "C" MIO_IO_API int disable_dio_interrupt(int devNum);
extern "C" MIO_IO_API int enable_dio_interrupt(int devNum);
extern "C" MIO_IO_API UCHAR read_dio_byte(int devNum, int offset);
extern "C" MIO_IO_API int set_dio_event(int devNum, HANDLE event);
extern "C" MIO_IO_API int write_dio_byte(int devNum, int offset, UCHAR value);

// MIOAD support functions
extern "C" MIO_IO_API int mio_enable_event_handling(int devNum, HANDLE *event);
extern "C" MIO_IO_API int mio_open_device(int devNum);
extern "C" MIO_IO_API int mio_read_irq_assigned(int devNum);
extern "C" MIO_IO_API UCHAR mio_read_reg(int devNum, int offset);
extern "C" MIO_IO_API int mio_write_reg(int devNum, int offset, UCHAR value);

// variables
extern MIO_IO_API int mio_error_code;
extern MIO_IO_API char mio_error_string[];
