///****************************************************************************
//
//	Copyright 2011 by WinSystems Inc.
//
//	Permission is hereby granted to the purchaser of WinSystems CPU products
//  to distribute any binary file or files compiled using this source code
//	directly or in any work derived by the user from this file. In no case
//	may the source code, original or derived from this file, be distributed
//	to any third party except by explicit permission of WinSystems. This file
//	is distributed on an "as-is" basis and no warranty as to performance or
//	fitness of purposes is expressed or implied. In no case shall WinSystems
//	be liable for any direct or indirect loss or damage, real or consequential
//	resulting from the usage of this source code. It is the user's sole
//	responsibility to determine fitness for any considered purpose.
//
///****************************************************************************
//
//	Name	 : getall.cpp
//
//	Project	 : PCM-MIO-G Sample Application
//
//	Author	 : Paul DeMetrotion
//
///****************************************************************************
//
//	  Date		Revision	                Description
//	--------	--------	---------------------------------------------
//	 11/8/11	  1.0		  Original Release
//
///****************************************************************************

#include "stdafx.h"
#include "..\mio_io\mio_io.h"
#include <conio.h>

#define DEVNUM 0

USHORT values[32];

int _tmain(int argc, _TCHAR* argv[])
{
int channel = 0;
USHORT result;
float current;

	// We set the mode on all 16 channels to single-ended bibpolar +/- 10V
	// scale. This allows for any legal volage to be applied to any channel

	for(channel=0; channel < 16; channel++)
	{
		adc_set_channel_mode(DEVNUM,channel,ADC_SINGLE_ENDED,ADC_BIPOLAR,ADC_TOP_10V);

		// Check for possible errors 

		if(mio_error_code)
		{
			printf("Error occured - %s\n",mio_error_string);
			exit(1);
		}
	}

	// This is it. The result is 16 channels of data stored
	// in the "values array.
			
	adc_convert_all_channels(DEVNUM,values);

	// Check for possible errors

	if(mio_error_code)
	{
		printf("Error occured - %s\n",mio_error_string);
		exit(1);
	}

	// Now we'll actually look at the data, convert it to volts
	// and display the results

	for(channel = 0; channel < 16; channel++)
	{
		if(channel == 4 || channel == 8 || channel == 12)
			printf("\n");

		// Channel by channel retrieve the raw conversion data

		result = values[channel];

		// Convert our value to a voltage

		current = adc_convert_to_volts(DEVNUM,channel,result);

		//  Display each channel's voltage.

		printf("CH%2d%8.4f | ",channel,current);
	}

	printf("\n");

	return 0;
}


