///****************************************************************************
//
//	Copyright 2011 by WinSystems Inc.
//
//	Permission is hereby granted to the purchaser of WinSystems CPU products
//  to distribute any binary file or files compiled using this source code
//	directly or in any work derived by the user from this file. In no case
//	may the source code, original or derived from this file, be distributed
//	to any third party except by explicit permission of WinSystems. This file
//	is distributed on an "as-is" basis and no warranty as to performance or
//	fitness of purposes is expressed or implied. In no case shall WinSystems
//	be liable for any direct or indirect loss or damage, real or consequential
//	resulting from the usage of this source code. It is the user's sole
//	responsibility to determine fitness for any considered purpose.
//
///****************************************************************************
//
//	Name	 : getvolt.cpp
//
//	Project	 : PCM-MIO-G Sample Application
//
//	Author	 : Paul DeMetrotion
//
///****************************************************************************
//
//	  Date		Revision	                Description
//	--------	--------	---------------------------------------------
//	 11/8/11	  1.0		  Original Release
//
///****************************************************************************

#include "stdafx.h"
#include "..\mio_io\mio_io.h"
#include <stdio.h>
#include <conio.h>

#define DEVNUM 0

int _tmain(int argc, _TCHAR* argv[])
{
float value;
int device = DEVNUM;
int channel = 0;

	// Defult to device DEVNUM / channel 0, but allow a command line argument

	if(argc > 1)
	{
		device = atoi(argv[1]);
		channel = atoi(argv[2]);
	}

	//  Check device number for validity

	if(device < 0 || device > 3)
	{
		printf("Device number must be between 0 and 3 - Aborting\n");
		exit(0);
	}

	//  Check channel number for validity

	if(channel < 0 || channel > 15)
	{
		printf("Channel number must be between 0 and 15 - Aborting\n");
		exit(0);
	}

	// Here's the whole thing. Make the call get back a voltage

	value = adc_auto_get_channel_voltage(device, channel);

	// Check for an error condition

	if(mio_error_code)
	{
		printf("Error occured - %s\n",mio_error_string);
		exit(1);
	}

	// Print it out

	printf("Device %d : Channel %d = %9.5f\n",device,channel,value);

	return 0;

}

