///****************************************************************************
//
//	Copyright 2011 by WinSystems Inc.
//
//	Permission is hereby granted to the purchaser of WinSystems CPU products
//  to distribute any binary file or files compiled using this source code
//	directly or in any work derived by the user from this file. In no case
//	may the source code, original or derived from this file, be distributed
//	to any third party except by explicit permission of WinSystems. This file
//	is distributed on an "as-is" basis and no warranty as to performance or
//	fitness of purposes is expressed or implied. In no case shall WinSystems
//	be liable for any direct or indirect loss or damage, real or consequential
//	resulting from the usage of this source code. It is the user's sole
//	responsibility to determine fitness for any considered purpose.
//
///****************************************************************************
//
//	Name	 : dacbuff.cpp
//
//	Project	 : PCM-MIO-G Sample Application
//
//	Author	 : Paul DeMetrotion
//
///****************************************************************************
//
//	  Date		Revision	                Description
//	--------	--------	---------------------------------------------
//	 11/8/11	  1.0		  Original Release
//
///****************************************************************************

#include "stdafx.h"
#include "..\mio_io\mio_io.h"
#include <stdio.h>
#include <conio.h>

#define DEVNUM 0

UCHAR commands[16385];
USHORT values[16384];

int _tmain(int argc, _TCHAR* argv[])
{
	unsigned x;

	// Set all 8 DAC outputs to a known span +/- 10V
    for(x=0; x<8; x++)
	{
		set_dac_span(DEVNUM, x, DAC_SPAN_BI10);

		if(mio_error_code)
		{
			printf("\n%s\n",mio_error_string);
			exit(1);
		}
	}

    // For this program we are going to use only channel 0
    //   with 16384 updates.
    // The data will step up from -10V to +10V in 4/65536 increments
    for(x = 0; x < 16384; x++)
    {
		commands[x] = 0;
        values[x] = x * 4;
    }

    // We need to terminate the command so that it knows when its done
    commands[16384] = 0xff;
 
    // This program runs until a key is pressed. It prints nothing
    // on the screen to keep from slowing it down. To see the results
    // it would be necessary to attach an oscilloscope to DAC channel
    // 0.
	while(!_kbhit())
	{
		// This command returns when all 16,384 samples have been
		// sent to the DAC as fast as possible
		buffered_dac_output(DEVNUM,commands,values);

		if(mio_error_code)
		{
			printf("\n%s\n",mio_error_string);
			exit(2);
		}
	}

    _getch();
 
	return 0;
}
